-- Paulo5090r
-- Script du cultivateur Jean de Bru Toptiller 350 P
-- @date  18/01/18
--


Toptiller350P = {};

function Toptiller350P.prerequisitesPresent(specializations)
	  return true;
end;

function Toptiller350P:load(savegame)
	   
	self.toggleLadder = SpecializationUtil.callSpecializationsFunction("toggleLadder");
    self.manualLadderAnimation = getXMLString(self.xmlFile, "vehicle.Ladder#animationName");
    self.LadderRangeIndex = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.Ladder#rangeIndex"));
    self.isInRangeLadder = false;
    self.isLadderDown = true;	
	
	self.toggleLid = SpecializationUtil.callSpecializationsFunction("toggleLid");
    self.manualLidAnimation = getXMLString(self.xmlFile, "vehicle.Lid#animationName");
    self.LidRangeIndex = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.Lid#rangeIndex"));
    self.isInRangeLid = false;
    self.isLidDown = true;	
end;

function Toptiller350P:delete()
end;

function Toptiller350P:readStream(streamId, connection)

    local isLadderDown = streamReadBool(streamId);
	    self:toggleLadder(isLadderDown, true); 
		
	local isLidDown = streamReadBool(streamId);
	    self:toggleLid(isLidDown, true); 
end;

function Toptiller350P:writeStream(streamId, connection)
streamWriteBool(streamId, self.isLadderDown); 
streamWriteBool(streamId, self.isLidDown); 
end;

function Toptiller350P:mouseEvent(posX, posY, isDown, isUp, button)
end;

function Toptiller350P:keyEvent(unicode, sym, modifier, isDown) 
end;

function Toptiller350P:update(dt)

         if self.LadderRangeIndex then
		-- Manage key events for inrange Ladder --
		if self.isInRangeLadder then
			if InputBinding.hasEvent(InputBinding.IMPLEMENT_EXTRA2) then
				if self.isLadderDown then
					self:toggleLadder(false);
				else
					self:toggleLadder(true);
				end;
			end;
			-- Display key when in range --
			if self.isLadderDown then
				g_currentMission:addHelpButtonText(string.format(g_i18n:getText("MONTER")), InputBinding.IMPLEMENT_EXTRA2);
			else
				g_currentMission:addHelpButtonText(string.format(g_i18n:getText("BAISSER")), InputBinding.IMPLEMENT_EXTRA2);
			end;
		end;
	end;
	
	
         if self.LidRangeIndex then
		-- Manage key events for inrange Lid --
		if self.isInRangeLid then
			if InputBinding.hasEvent(InputBinding.IMPLEMENT_EXTRA3) then
				if self.isLidDown then
					self:toggleLid(false);
				else
					self:toggleLid(true);
				end;
			end;
			-- Display key when in range --
			if self.isLidDown then
				g_currentMission:addHelpButtonText(string.format(g_i18n:getText("FERMER")), InputBinding.IMPLEMENT_EXTRA3);
			else
				g_currentMission:addHelpButtonText(string.format(g_i18n:getText("OUVRIR")), InputBinding.IMPLEMENT_EXTRA3);
			end;
		end;
	end;
end;

function Toptiller350P:updateTick(dt)

	 if self.LadderRangeIndex then
		if g_currentMission.player ~= nil then
			-- Getting the distance between the player and the Ladder
			local nearestDistance = 1.5; --max distance allowed
			local px, py, pz = getWorldTranslation(self.LadderRangeIndex);
			local vx, vy, vz = getWorldTranslation(g_currentMission.player.rootNode);
			local distance = Utils.vector3Length(px-vx, py-vy, pz-vz);
			if distance < nearestDistance then
				self.isInRangeLadder = true;
			else
				self.isInRangeLadder = false;
			end;
		end;
	else
		self.isInRangeLadder = false;
	end;
	
	 if self.LidRangeIndex then
		if g_currentMission.player ~= nil then
			-- Getting the distance between the player and the Lid
			local nearestDistance = 1.5; --max distance allowed
			local px, py, pz = getWorldTranslation(self.LidRangeIndex);
			local vx, vy, vz = getWorldTranslation(g_currentMission.player.rootNode);
			local distance = Utils.vector3Length(px-vx, py-vy, pz-vz);
			if distance < nearestDistance then
				self.isInRangeLid = true;
			else
				self.isInRangeLid = false;
			end;
		end;
	else
		self.isInRangeLid = false;
	end;
end;

function Toptiller350P:postLoad(savegame)
	if savegame ~= nil and not savegame.resetVehicles then
	local isLadderDown = Utils.getNoNil(getXMLBool(savegame.xmlFile, savegame.key .. "#isLadderDown"), false);
	self:toggleLadder(isLadderDown);
    end;
	
	if savegame ~= nil and not savegame.resetVehicles then
	local isLidDown = Utils.getNoNil(getXMLBool(savegame.xmlFile, savegame.key .. "#isLidDown"), false);
	self:toggleLid(isLidDown);
    end;
end;

function Toptiller350P:getSaveAttributesAndNodes(nodeIdent)		
    local attributes = ' isLadderDown="' .. tostring(self.isLadderDown)..'"';
	local nodes = nil;
    return attributes,nodes;
end;

function Toptiller350P:getSaveAttributesAndNodes(nodeIdent)		
	local attributes = ' isLidDown="' .. tostring(self.isLidDown)..'"';
	local nodes = nil;
    return attributes,nodes;
end;
  
function Toptiller350P:draw() 
if g_currentMission.showHelpText and self.isClient then
      g_currentMission:addExtraPrintText(g_i18n:getText("HELP"));	
end;
end;

function Toptiller350P:toggleLadder(isLadderDown, noEventSend)
	ToggleLadderEvent.sendEvent(self, isLadderDown, noEventSend);	
	
	if not isLadderDown then
		if self.manualLadderAnimation ~= nil and self.playAnimation ~= nil then
			self:playAnimation(self.manualLadderAnimation, 1, nil, true);
		end;
	else
		if self.manualLadderAnimation ~= nil and self.playAnimation ~= nil then
			self:playAnimation(self.manualLadderAnimation, -1, nil, true);
		end;
	end;
	
	self.isLadderDown = isLadderDown;
end;

function Toptiller350P:toggleLid(isLidDown, noEventSend)
	ToggleLidEvent.sendEvent(self, isLidDown, noEventSend);	
	
	if not isLidDown then
		if self.manualLidAnimation ~= nil and self.playAnimation ~= nil then
			self:playAnimation(self.manualLidAnimation, 1, nil, true);
		end;
	else
		if self.manualLidAnimation ~= nil and self.playAnimation ~= nil then
			self:playAnimation(self.manualLidAnimation, -1, nil, true);
		end;
	end;
	
	self.isLidDown = isLidDown;
end;

-- Ladder event --

ToggleLadderEvent = {};
ToggleLadderEvent_mt = Class(ToggleLadderEvent, Event);

InitEventClass(ToggleLadderEvent, "ToggleLadderEvent");

function ToggleLadderEvent:emptyNew()
    local self = Event:new(ToggleLadderEvent_mt);
    return self;
end;

function ToggleLadderEvent:new(object, isLadderDown)
    local self = ToggleLadderEvent:emptyNew()
    self.object = object;
	self.isLadderDown = isLadderDown;
    return self;
end;

function ToggleLadderEvent:readStream(streamId, connection)
    local id = streamReadInt32(streamId);
	self.object = networkGetObject(id);
	self.isLadderDown = streamReadBool(streamId);
    self:run(connection);
end;

function ToggleLadderEvent:writeStream(streamId, connection)
    streamWriteInt32(streamId, networkGetObjectId(self.object));	
	streamWriteBool(streamId, self.isLadderDown);
end;

function ToggleLadderEvent:run(connection)
	self.object:toggleLadder(self.isLadderDown, true);
end;

function ToggleLadderEvent.sendEvent(object, isLadderDown, noEventSend)
	
	if noEventSend == nil or noEventSend == false then
		if g_server ~= nil then
			g_server:broadcastEvent(ToggleLadderEvent:new(object, isLadderDown), nil, nil, object);
		else
			g_client:getServerConnection():sendEvent(ToggleLadderEvent:new(object, isLadderDown));
		end;
	end;
end;

-- Lid event --

ToggleLidEvent = {};
ToggleLidEvent_mt = Class(ToggleLidEvent, Event);

InitEventClass(ToggleLidEvent, "ToggleLidEvent");

function ToggleLidEvent:emptyNew()
    local self = Event:new(ToggleLidEvent_mt);
    return self;
end;

function ToggleLidEvent:new(object, isLidDown)
    local self = ToggleLidEvent:emptyNew()
    self.object = object;
	self.isLidDown = isLidDown;
    return self;
end;

function ToggleLidEvent:readStream(streamId, connection)
    local id = streamReadInt32(streamId);
	self.object = networkGetObject(id);
	self.isLidDown = streamReadBool(streamId);
    self:run(connection);
end;

function ToggleLidEvent:writeStream(streamId, connection)
    streamWriteInt32(streamId, networkGetObjectId(self.object));	
	streamWriteBool(streamId, self.isLidDown);
end;

function ToggleLidEvent:run(connection)
	self.object:toggleLid(self.isLidDown, true);
end;

function ToggleLidEvent.sendEvent(object, isLidDown, noEventSend)
	
	if noEventSend == nil or noEventSend == false then
		if g_server ~= nil then
			g_server:broadcastEvent(ToggleLidEvent:new(object, isLidDown), nil, nil, object);
		else
			g_client:getServerConnection():sendEvent(ToggleLidEvent:new(object, isLidDown));
		end;
	end;
end;